/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 *
 *  Copyright (C) 2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: rcb3.c 122 2015-07-17 01:31:28Z ertl-honda $
 */
/*
 *		RCB3ʸϽ
 */
#include "Os.h"
#include "rcb3.h"

/*
 *  PS3ȥΥܥο
 */
#define PS3_NUM_OF_BUTTON 14
#define PS3_NUM_OF_ANALOG 4

/*
 *  ʸեޥåȤΥ
 */
enum rcb3_st {
	RCB3_ST_HEADER_1,
	RCB3_ST_BUTTON_1,
	RCB3_ST_BUTTON_2, 
	RCB3_ST_ANALOG_1,
	RCB3_ST_ANALOG_2,
	RCB3_ST_ANALOG_3,
	RCB3_ST_ANALOG_4,
	RCB3_ST_SUM, 
};

/*
 *  åѥХѿ
 */
static enum rcb3_st s_rcb3_st = RCB3_ST_HEADER_1;
static int			s_rcb3_rmsg_cnt;
uint8				g_rcb3_rmsg[RCB3_MSG_LEN];

/*
 *  ܥåȽѥХѿ
 */
static const uint16 msg_button_pattern[PS3_NUM_OF_BUTTON] = {
	RCB3_MSG_BUTTON_UP,
	RCB3_MSG_BUTTON_DOWN,
	RCB3_MSG_BUTTON_LEFT,
	RCB3_MSG_BUTTON_RIGHT,
	RCB3_MSG_BUTTON_TRIANGLE,
	RCB3_MSG_BUTTON_CROSS,
	RCB3_MSG_BUTTON_NOUGHT,
	RCB3_MSG_BUTTON_SQUARE,
	RCB3_MSG_BUTTON_L1,
	RCB3_MSG_BUTTON_L2,
	RCB3_MSG_BUTTON_R1,
	RCB3_MSG_BUTTON_R2,
	RCB3_MSG_BUTTON_START,
	RCB3_MSG_BUTTON_SELECT
};

/*
 *  ܥݻѥХѿ
 *   ֥ХåեȤ֤ȸ߾֤¸
 */
static boolean	s_ps3button[2][PS3_NUM_OF_BUTTON];
static sint8	 s_ps3analog[2][PS3_NUM_OF_ANALOG];

/*
 * ֤ȸ߾֤򼨤ݥ
 */
boolean	*p_g_pre_ps3button;
boolean	*p_g_cur_ps3button;
sint8	*p_g_pre_ps3analog;
sint8	*p_g_cur_ps3analog;


void
rcb3_Init(void)
{
	/* Init button */
	p_g_pre_ps3button = s_ps3button[0];
	p_g_cur_ps3button = s_ps3button[1];
	p_g_pre_ps3analog = s_ps3analog[0];
	p_g_cur_ps3analog = s_ps3analog[1];
}

/*
 *  ܥ2ХȤȤʤäƤ뤿2ХȥǡȤ᤹
 */
static uint16
rcb3_GetReceivedButton()
{
	uint16 button_cmd;

	button_cmd = (g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_H] << 8) | g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_L];

	return button_cmd;
}

/*
 *  ܥ֤ι
 */
static void
rcb3_UpdateStatus(void)
{
	boolean *tmp_button;
	sint8 *tmp_analog;
	int i;
	uint16 button = rcb3_GetReceivedButton();

	/*
	 *  ֤ȸ߾֤Υݥ󥿤򹹿
	 */
	tmp_button = p_g_pre_ps3button;
	tmp_analog = p_g_pre_ps3analog;

	p_g_pre_ps3button = p_g_cur_ps3button;
	p_g_pre_ps3analog = p_g_cur_ps3analog;

	p_g_cur_ps3button = tmp_button;
	p_g_cur_ps3analog = tmp_analog;

	/*
	 *  ߤΥǥܥξ֤򹹿
	 */
	for(i = 0; i < PS3_NUM_OF_BUTTON; i++) {
		if ((button & msg_button_pattern[i])) {
			p_g_cur_ps3button[i] = TRUE;
		}
		else {
			p_g_cur_ps3button[i] = FALSE;
		}
	}

	/*
	 *  ߤΥʥܥξ֤򹹿
	 */
	for(i = 0; i < PS3_NUM_OF_ANALOG; i++) {
		uint8 val = g_rcb3_rmsg[RCB3_MSG_OFFSET_L_ANALOG_LR + i];
		p_g_cur_ps3analog[i] = ((sint8)val - RCB3_MSG_ANALOG_NEUTRAL);
	}
}

/*
 *  RCB3ޥɤβ
 * 
 *  1Х˰˻ꤷƸƤӽФ
 *  ʸκǸTRUE֤
 */
boolean
rcb3_AddReceivedByte(uint8 c)
{
	boolean rval = FALSE;
	int i;
	uint8 sum = 0;

	switch (s_rcb3_st) {
	case RCB3_ST_HEADER_1:
		if (c == RCB3_MSG_HEADER_1) {
			s_rcb3_rmsg_cnt = 0;
			g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
			s_rcb3_st = RCB3_ST_BUTTON_1;
		}
		break;
	case RCB3_ST_BUTTON_1:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_BUTTON_2;
		break;
	case RCB3_ST_BUTTON_2:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_ANALOG_1;
		break;
	case RCB3_ST_ANALOG_1:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_ANALOG_2;
		break;
	case RCB3_ST_ANALOG_2:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_ANALOG_3;
		break;
	case RCB3_ST_ANALOG_3:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_ANALOG_4;
		break;
	case RCB3_ST_ANALOG_4:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		s_rcb3_st = RCB3_ST_SUM;
		break;
	case RCB3_ST_SUM:
		g_rcb3_rmsg[s_rcb3_rmsg_cnt++] = c;
		for(i = 1; i < (RCB3_MSG_LEN - 1); i++) {
			sum += g_rcb3_rmsg[i];
		}
		sum &= 0x7f;
		if (c == sum) {
			rcb3_UpdateStatus();
			rval = TRUE;
		}
		else{
			rcb3_ErrorCb(sum, c, g_rcb3_rmsg);
		}
		s_rcb3_st = RCB3_ST_HEADER_1;
		break;
	}
	return rval;
}
